/*
Authorization Service API v. 1.0

<a href='https://cern.service-now.com/service-portal?id=privacy_policy&se=SSO-Service&notice=resources'>Privacy notice</a>

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package authzapiv1

import (
	"encoding/json"
)

// checks if the GroupMemberTask type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &GroupMemberTask{}

// GroupMemberTask struct for GroupMemberTask
type GroupMemberTask struct {
	Result                  *GroupMember         `json:"result,omitempty"`
	Id                      *int32               `json:"id,omitempty"`
	Exception               interface{}          `json:"exception,omitempty"`
	Status                  *TaskStatus          `json:"status,omitempty"`
	IsCanceled              *bool                `json:"isCanceled,omitempty"`
	IsCompleted             *bool                `json:"isCompleted,omitempty"`
	IsCompletedSuccessfully *bool                `json:"isCompletedSuccessfully,omitempty"`
	CreationOptions         *TaskCreationOptions `json:"creationOptions,omitempty"`
	AsyncState              interface{}          `json:"asyncState,omitempty"`
	IsFaulted               *bool                `json:"isFaulted,omitempty"`
}

// NewGroupMemberTask instantiates a new GroupMemberTask object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewGroupMemberTask() *GroupMemberTask {
	this := GroupMemberTask{}
	return &this
}

// NewGroupMemberTaskWithDefaults instantiates a new GroupMemberTask object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewGroupMemberTaskWithDefaults() *GroupMemberTask {
	this := GroupMemberTask{}
	return &this
}

// GetResult returns the Result field value if set, zero value otherwise.
func (o *GroupMemberTask) GetResult() GroupMember {
	if o == nil || IsNil(o.Result) {
		var ret GroupMember
		return ret
	}
	return *o.Result
}

// GetResultOk returns a tuple with the Result field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GroupMemberTask) GetResultOk() (*GroupMember, bool) {
	if o == nil || IsNil(o.Result) {
		return nil, false
	}
	return o.Result, true
}

// HasResult returns a boolean if a field has been set.
func (o *GroupMemberTask) HasResult() bool {
	if o != nil && !IsNil(o.Result) {
		return true
	}

	return false
}

// SetResult gets a reference to the given GroupMember and assigns it to the Result field.
func (o *GroupMemberTask) SetResult(v GroupMember) {
	o.Result = &v
}

// GetId returns the Id field value if set, zero value otherwise.
func (o *GroupMemberTask) GetId() int32 {
	if o == nil || IsNil(o.Id) {
		var ret int32
		return ret
	}
	return *o.Id
}

// GetIdOk returns a tuple with the Id field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GroupMemberTask) GetIdOk() (*int32, bool) {
	if o == nil || IsNil(o.Id) {
		return nil, false
	}
	return o.Id, true
}

// HasId returns a boolean if a field has been set.
func (o *GroupMemberTask) HasId() bool {
	if o != nil && !IsNil(o.Id) {
		return true
	}

	return false
}

// SetId gets a reference to the given int32 and assigns it to the Id field.
func (o *GroupMemberTask) SetId(v int32) {
	o.Id = &v
}

// GetException returns the Exception field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *GroupMemberTask) GetException() interface{} {
	if o == nil {
		var ret interface{}
		return ret
	}
	return o.Exception
}

// GetExceptionOk returns a tuple with the Exception field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *GroupMemberTask) GetExceptionOk() (*interface{}, bool) {
	if o == nil || IsNil(o.Exception) {
		return nil, false
	}
	return &o.Exception, true
}

// HasException returns a boolean if a field has been set.
func (o *GroupMemberTask) HasException() bool {
	if o != nil && !IsNil(o.Exception) {
		return true
	}

	return false
}

// SetException gets a reference to the given interface{} and assigns it to the Exception field.
func (o *GroupMemberTask) SetException(v interface{}) {
	o.Exception = v
}

// GetStatus returns the Status field value if set, zero value otherwise.
func (o *GroupMemberTask) GetStatus() TaskStatus {
	if o == nil || IsNil(o.Status) {
		var ret TaskStatus
		return ret
	}
	return *o.Status
}

// GetStatusOk returns a tuple with the Status field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GroupMemberTask) GetStatusOk() (*TaskStatus, bool) {
	if o == nil || IsNil(o.Status) {
		return nil, false
	}
	return o.Status, true
}

// HasStatus returns a boolean if a field has been set.
func (o *GroupMemberTask) HasStatus() bool {
	if o != nil && !IsNil(o.Status) {
		return true
	}

	return false
}

// SetStatus gets a reference to the given TaskStatus and assigns it to the Status field.
func (o *GroupMemberTask) SetStatus(v TaskStatus) {
	o.Status = &v
}

// GetIsCanceled returns the IsCanceled field value if set, zero value otherwise.
func (o *GroupMemberTask) GetIsCanceled() bool {
	if o == nil || IsNil(o.IsCanceled) {
		var ret bool
		return ret
	}
	return *o.IsCanceled
}

// GetIsCanceledOk returns a tuple with the IsCanceled field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GroupMemberTask) GetIsCanceledOk() (*bool, bool) {
	if o == nil || IsNil(o.IsCanceled) {
		return nil, false
	}
	return o.IsCanceled, true
}

// HasIsCanceled returns a boolean if a field has been set.
func (o *GroupMemberTask) HasIsCanceled() bool {
	if o != nil && !IsNil(o.IsCanceled) {
		return true
	}

	return false
}

// SetIsCanceled gets a reference to the given bool and assigns it to the IsCanceled field.
func (o *GroupMemberTask) SetIsCanceled(v bool) {
	o.IsCanceled = &v
}

// GetIsCompleted returns the IsCompleted field value if set, zero value otherwise.
func (o *GroupMemberTask) GetIsCompleted() bool {
	if o == nil || IsNil(o.IsCompleted) {
		var ret bool
		return ret
	}
	return *o.IsCompleted
}

// GetIsCompletedOk returns a tuple with the IsCompleted field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GroupMemberTask) GetIsCompletedOk() (*bool, bool) {
	if o == nil || IsNil(o.IsCompleted) {
		return nil, false
	}
	return o.IsCompleted, true
}

// HasIsCompleted returns a boolean if a field has been set.
func (o *GroupMemberTask) HasIsCompleted() bool {
	if o != nil && !IsNil(o.IsCompleted) {
		return true
	}

	return false
}

// SetIsCompleted gets a reference to the given bool and assigns it to the IsCompleted field.
func (o *GroupMemberTask) SetIsCompleted(v bool) {
	o.IsCompleted = &v
}

// GetIsCompletedSuccessfully returns the IsCompletedSuccessfully field value if set, zero value otherwise.
func (o *GroupMemberTask) GetIsCompletedSuccessfully() bool {
	if o == nil || IsNil(o.IsCompletedSuccessfully) {
		var ret bool
		return ret
	}
	return *o.IsCompletedSuccessfully
}

// GetIsCompletedSuccessfullyOk returns a tuple with the IsCompletedSuccessfully field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GroupMemberTask) GetIsCompletedSuccessfullyOk() (*bool, bool) {
	if o == nil || IsNil(o.IsCompletedSuccessfully) {
		return nil, false
	}
	return o.IsCompletedSuccessfully, true
}

// HasIsCompletedSuccessfully returns a boolean if a field has been set.
func (o *GroupMemberTask) HasIsCompletedSuccessfully() bool {
	if o != nil && !IsNil(o.IsCompletedSuccessfully) {
		return true
	}

	return false
}

// SetIsCompletedSuccessfully gets a reference to the given bool and assigns it to the IsCompletedSuccessfully field.
func (o *GroupMemberTask) SetIsCompletedSuccessfully(v bool) {
	o.IsCompletedSuccessfully = &v
}

// GetCreationOptions returns the CreationOptions field value if set, zero value otherwise.
func (o *GroupMemberTask) GetCreationOptions() TaskCreationOptions {
	if o == nil || IsNil(o.CreationOptions) {
		var ret TaskCreationOptions
		return ret
	}
	return *o.CreationOptions
}

// GetCreationOptionsOk returns a tuple with the CreationOptions field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GroupMemberTask) GetCreationOptionsOk() (*TaskCreationOptions, bool) {
	if o == nil || IsNil(o.CreationOptions) {
		return nil, false
	}
	return o.CreationOptions, true
}

// HasCreationOptions returns a boolean if a field has been set.
func (o *GroupMemberTask) HasCreationOptions() bool {
	if o != nil && !IsNil(o.CreationOptions) {
		return true
	}

	return false
}

// SetCreationOptions gets a reference to the given TaskCreationOptions and assigns it to the CreationOptions field.
func (o *GroupMemberTask) SetCreationOptions(v TaskCreationOptions) {
	o.CreationOptions = &v
}

// GetAsyncState returns the AsyncState field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *GroupMemberTask) GetAsyncState() interface{} {
	if o == nil {
		var ret interface{}
		return ret
	}
	return o.AsyncState
}

// GetAsyncStateOk returns a tuple with the AsyncState field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *GroupMemberTask) GetAsyncStateOk() (*interface{}, bool) {
	if o == nil || IsNil(o.AsyncState) {
		return nil, false
	}
	return &o.AsyncState, true
}

// HasAsyncState returns a boolean if a field has been set.
func (o *GroupMemberTask) HasAsyncState() bool {
	if o != nil && !IsNil(o.AsyncState) {
		return true
	}

	return false
}

// SetAsyncState gets a reference to the given interface{} and assigns it to the AsyncState field.
func (o *GroupMemberTask) SetAsyncState(v interface{}) {
	o.AsyncState = v
}

// GetIsFaulted returns the IsFaulted field value if set, zero value otherwise.
func (o *GroupMemberTask) GetIsFaulted() bool {
	if o == nil || IsNil(o.IsFaulted) {
		var ret bool
		return ret
	}
	return *o.IsFaulted
}

// GetIsFaultedOk returns a tuple with the IsFaulted field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GroupMemberTask) GetIsFaultedOk() (*bool, bool) {
	if o == nil || IsNil(o.IsFaulted) {
		return nil, false
	}
	return o.IsFaulted, true
}

// HasIsFaulted returns a boolean if a field has been set.
func (o *GroupMemberTask) HasIsFaulted() bool {
	if o != nil && !IsNil(o.IsFaulted) {
		return true
	}

	return false
}

// SetIsFaulted gets a reference to the given bool and assigns it to the IsFaulted field.
func (o *GroupMemberTask) SetIsFaulted(v bool) {
	o.IsFaulted = &v
}

func (o GroupMemberTask) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o GroupMemberTask) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Result) {
		toSerialize["result"] = o.Result
	}
	if !IsNil(o.Id) {
		toSerialize["id"] = o.Id
	}
	if o.Exception != nil {
		toSerialize["exception"] = o.Exception
	}
	if !IsNil(o.Status) {
		toSerialize["status"] = o.Status
	}
	if !IsNil(o.IsCanceled) {
		toSerialize["isCanceled"] = o.IsCanceled
	}
	if !IsNil(o.IsCompleted) {
		toSerialize["isCompleted"] = o.IsCompleted
	}
	if !IsNil(o.IsCompletedSuccessfully) {
		toSerialize["isCompletedSuccessfully"] = o.IsCompletedSuccessfully
	}
	if !IsNil(o.CreationOptions) {
		toSerialize["creationOptions"] = o.CreationOptions
	}
	if o.AsyncState != nil {
		toSerialize["asyncState"] = o.AsyncState
	}
	if !IsNil(o.IsFaulted) {
		toSerialize["isFaulted"] = o.IsFaulted
	}
	return toSerialize, nil
}

type NullableGroupMemberTask struct {
	value *GroupMemberTask
	isSet bool
}

func (v NullableGroupMemberTask) Get() *GroupMemberTask {
	return v.value
}

func (v *NullableGroupMemberTask) Set(val *GroupMemberTask) {
	v.value = val
	v.isSet = true
}

func (v NullableGroupMemberTask) IsSet() bool {
	return v.isSet
}

func (v *NullableGroupMemberTask) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableGroupMemberTask(val *GroupMemberTask) *NullableGroupMemberTask {
	return &NullableGroupMemberTask{value: val, isSet: true}
}

func (v NullableGroupMemberTask) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableGroupMemberTask) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
